/**
 * Area Chart Controller.
 * This controller sets areaChartConfig, sets in correct scope and passes in usersChartConfig.
 * Sets userChartConfig that is watched in base controller(DefaultChartController).
 */
import areaChartConfig from './areaChart-config';
import DefaultChartController from "../defaultChart-controller";
export default class AreaChartController extends DefaultChartController{

    userChartConfig:Highcharts.Options;
    static $inject = ['$scope', '$element'];

    constructor(private $scope, private $element){
        //invoking base controller and passing in areaChart components scope, element and lineChart's configuration.
        super($scope, $element, areaChartConfig);
    }

    getUserChartConfig():Highcharts.Options {
        return this.userChartConfig;
    }
}