import NwfValidator from '../nwfValidator';

class IsFuncTrueValidatorController extends NwfValidator {

    static $inject = ['$scope', '$element'];

    isFuncTrue: any;

    constructor(private $scope: ng.IScope, private $element: ng.IAugmentedJQuery) {
        super($element);
        this.invalidMessage = this.invalidMessage || 'This is invalid';
        this.emptyMessage = this.emptyMessage || 'You have to provide a value';
        this.myEl.setAttribute('title', '');
    }

    invalidHandler() {
        //Hitting $apply.
        this.$scope.$apply();
        if (this.myEl.validity.valueMissing) {
            this.myEl.setCustomValidity(this.emptyMessage);
        } else if (!this.isFuncTrue(this.myEl.value)) {
            this.myEl.setCustomValidity(this.invalidMessage);
        } else {
            //else we set validity='', which makes its validity.valid = true;
            this.myEl.setCustomValidity('');
        }
    }

}

export class IsFuncTrueValidator {
    static NAME: string = 'isFuncTrue';
    bindToController = {
        emptyMessage: '@?',
        invalidMessage: '@?',
        isFuncTrue: '<'
    };
    restrict = 'A';
    controller = IsFuncTrueValidatorController;
}

// export factory function
export function IsFuncTrueValidatorFactory(): IsFuncTrueValidator {
    return new IsFuncTrueValidator();
}
