import NwfValidator from '../nwfValidator';

class IsNumberValidatorController extends NwfValidator {

    invalidMaxMessage: string;
    invalidMinMessage: string;

    static $inject = ['$element', '$i18next'];

    constructor(private $element: ng.IAugmentedJQuery, private $i18next) {
        super($element);
        var el = $element.get(0);
        this.myEl.setAttribute('type', 'number');
        this.invalidMessage = this.invalidMessage || $i18next.t('nwfjs:isNumberInvalidMessage');
        this.invalidMinMessage = this.invalidMinMessage || $i18next.t('nwfjs:isNumberInvalidMinMessage') + el.getAttribute('min');
        this.invalidMaxMessage = this.invalidMaxMessage || $i18next.t('nwfjs:isNumberInvalidMaxMessage') + el.getAttribute('max');
        this.emptyMessage = this.emptyMessage || $i18next.t('nwfjs:emptyMessage');
    }

    invalidHandler() {
        super.invalidHandler();
        if (this.myEl.validity.rangeOverflow) {
            this.myEl.setCustomValidity(this.invalidMaxMessage);
        } else if (this.myEl.validity.rangeUnderflow) {
            this.myEl.setCustomValidity(this.invalidMinMessage);
        } else {
            this.myEl.setCustomValidity('');
        }
    }
}

export class IsNumberValidator {

    static NAME: string = 'isNumber';
    bindToController = {
        emptyMessage: '@?',
        invalidMessage: '@?',
        invalidMaxMessage: '@?',
        invalidMinMessage: '@'
    };
    restrict = 'A';
    controller = IsNumberValidatorController;
    controllerAs = 'numberCtrl';
}

// export factory function
export function IsNumberValidatorFactory(): IsNumberValidator {
    return new IsNumberValidator();
}
