/**
 * Configuration provider to set configuration data to NwfJS.
 * Every application will have its help context and can use the help directive by passing in screen specific GUID after that.
 */

export default function () {
    var helpContext: string;
    var helpBasePath = "OnCommand/help/netapp/";
    var helpContextRoot = document.location.pathname.replace('index.html', '');
    var contentType: string = 'application/vnd.netapp.ocf-core.v1.hal+json';
    var registryURL: string;

    return {

        setHelpContext: function (_helpCont) {
            helpContext = _helpCont;
        },

        setHelpBasePath: function (_basePath) {
            helpBasePath = _basePath;
        },

        setHelpContextRoot: function (_helpContextRoot) {
            helpContextRoot = _helpContextRoot;
        },

        $get: function () {
            return {
                getHelpContext: function () {
                    return helpContext;
                },
                getHelpContextRoot: function () {
                    return helpContextRoot + helpBasePath;
                },
                getContentType: function () {
                    return contentType;
                }
            };
        }
    };
}
