import * as ng from 'angular';

export default class LeftNavController {

    private navData;
    private isNavMinimized = false;

    static $inject = ['$rootScope'];

    constructor(private $rootScope) {

    }

    $onInit() {
        /* Set my initial state */
        if (!this.isNavMinimized) {
            this.showOrHideNav(true);
        }
    }

    toggleNav() {
        var showMe = this.isNavMinimized = !this.isNavMinimized;
        if (!showMe) {
            this.showOrHideNav(true);
        } else {
            this.showOrHideNav(false);
        }
    }

    onItemMouseEnter($evt) {
        if (!$evt.target.classList.contains('icon-hamburger') && this.isNavMinimized) {
            this.showOrHideNav(true);
        }
    }

    private showOrHideNav(showOrHide: boolean) {
        this.isNavMinimized = !showOrHide;
        var body = ng.element('body');
        let navActive = 'nav-is-active';
        if (showOrHide === true) {
            body.addClass(navActive);
        } else {
            /* hide the leftnav (full width) */
            body.removeClass(navActive);
        }
        setTimeout(() => this.$rootScope.$broadcast('leftNav-resize'), 310);
    }

}
