import * as logoutFailedModalTemplate from './nwfLogout-failed-dialog.html';

export default class NwfLogoutController {
    static $inject = ['$scope', '$uibModal', 'authStrategy'];
    constructor($scope, $uibModal, authStrategy) {
        // Controller used by logout failed dialog.
        var logoutFailedController = ['$scope', '$uibModalInstance',
            function ($scope, $uibModalInstance) {
                $scope.ok = function () {
                    $uibModalInstance.close();
                };
            }
        ];

        //Logout call.
        $scope.logoutFn = function () {
            authStrategy.logoutFn().then(function () {
                authStrategy.navigateToLoginPage(true);
            }).catch(function () {
                $uibModal.open({
                    template: logoutFailedModalTemplate,
                    controller: logoutFailedController,
                    windowClass: 'nwf-login-error-modal',
                    backdrop: 'static'
                });
            });
        }
    }
}
